-- This file is automatically generated using maintenance/generateSchemaSql.php.
-- Source: sql/tables.json
-- Do not modify this file directly.
-- See https://www.mediawiki.org/wiki/Manual:Schema_changes
CREATE TABLE /*_*/thread (
  thread_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  thread_root INTEGER UNSIGNED NOT NULL,
  thread_ancestor INTEGER UNSIGNED NOT NULL,
  thread_parent INTEGER UNSIGNED DEFAULT NULL,
  thread_summary_page INTEGER UNSIGNED DEFAULT NULL,
  thread_subject VARCHAR(255) DEFAULT NULL,
  thread_author_id INTEGER UNSIGNED DEFAULT NULL,
  thread_author_name VARCHAR(255) DEFAULT NULL,
  thread_modified BLOB NOT NULL,
  thread_created BLOB NOT NULL,
  thread_editedness INTEGER DEFAULT 0 NOT NULL,
  thread_article_namespace INTEGER NOT NULL,
  thread_article_title BLOB NOT NULL,
  thread_article_id INTEGER UNSIGNED NOT NULL,
  thread_type INTEGER UNSIGNED DEFAULT 0 NOT NULL,
  thread_sortkey VARCHAR(255) DEFAULT '' NOT NULL,
  thread_replies INTEGER DEFAULT -1,
  thread_signature BLOB DEFAULT NULL
);

CREATE UNIQUE INDEX thread_root ON /*_*/thread (thread_root);

CREATE INDEX thread_ancestor ON /*_*/thread (thread_ancestor, thread_parent);

CREATE INDEX thread_article_title ON /*_*/thread (
  thread_article_namespace, thread_article_title,
  thread_sortkey
);

CREATE INDEX thread_article ON /*_*/thread (
  thread_article_id, thread_sortkey
);

CREATE INDEX thread_modified ON /*_*/thread (thread_modified);

CREATE INDEX thread_created ON /*_*/thread (thread_created);

CREATE INDEX thread_summary_page ON /*_*/thread (thread_summary_page);

CREATE INDEX thread_author_name ON /*_*/thread (
  thread_author_id, thread_author_name
);

CREATE INDEX thread_sortkey ON /*_*/thread (thread_sortkey);

CREATE INDEX thread_parent ON /*_*/thread (thread_parent);


CREATE TABLE /*_*/historical_thread (
  hthread_id INTEGER UNSIGNED NOT NULL,
  hthread_revision INTEGER UNSIGNED NOT NULL,
  hthread_contents BLOB NOT NULL,
  hthread_change_type INTEGER UNSIGNED NOT NULL,
  hthread_change_object INTEGER UNSIGNED DEFAULT NULL,
  PRIMARY KEY(hthread_id, hthread_revision)
);


CREATE TABLE /*_*/user_message_state (
  ums_user INTEGER UNSIGNED NOT NULL,
  ums_thread INTEGER UNSIGNED NOT NULL,
  ums_conversation INTEGER UNSIGNED DEFAULT 0 NOT NULL,
  ums_read_timestamp BLOB DEFAULT NULL,
  PRIMARY KEY(ums_user, ums_thread)
);

CREATE INDEX ums_user_conversation ON /*_*/user_message_state (ums_user, ums_conversation);


CREATE TABLE /*_*/thread_history (
  th_id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
  th_thread INTEGER UNSIGNED NOT NULL,
  th_timestamp BLOB NOT NULL,
  th_user INTEGER UNSIGNED NOT NULL,
  th_user_text VARCHAR(255) NOT NULL,
  th_change_type INTEGER UNSIGNED NOT NULL,
  th_change_object INTEGER UNSIGNED NOT NULL,
  th_change_comment CLOB NOT NULL,
  th_content BLOB NOT NULL
);

CREATE INDEX th_thread_timestamp ON /*_*/thread_history (th_thread, th_timestamp);

CREATE INDEX th_timestamp_thread ON /*_*/thread_history (th_timestamp, th_thread);

CREATE INDEX th_user_text ON /*_*/thread_history (th_user, th_user_text);


CREATE TABLE /*_*/thread_pending_relationship (
  tpr_thread INTEGER UNSIGNED NOT NULL,
  tpr_relationship BLOB NOT NULL,
  tpr_title BLOB NOT NULL,
  tpr_type BLOB NOT NULL,
  PRIMARY KEY(tpr_thread, tpr_relationship)
);


CREATE TABLE /*_*/thread_reaction (
  tr_thread INTEGER UNSIGNED NOT NULL,
  tr_user INTEGER UNSIGNED NOT NULL,
  tr_user_text BLOB NOT NULL,
  tr_type BLOB NOT NULL,
  tr_value INTEGER NOT NULL,
  PRIMARY KEY(
    tr_thread, tr_user, tr_user_text,
    tr_type, tr_value
  )
);

CREATE INDEX tr_user_text_value ON /*_*/thread_reaction (
  tr_user, tr_user_text, tr_type, tr_value
);
